﻿//Función para reemplazar cadenas de texto
function strReplace(busca, sust, cadena) {
	return cadena.split(busca).join(sust);
}
//
//
//Función para ordenar el array por el parámetro name de los objetos, ya que no hay
//una función sortOn
function nameSort(i, j) {
	//Estas funciones tienen que tener una sintaxis como esta en la que se devuelva
	//-1 si un objeto se considera menor que otro y 1 si se considera mayor.
	// ">" y "<" se refieren al orden alfabético cuando comparan cadenas.
	return (i.name<j.name ? -1 : 1);
}
//
//
//
//Cojo la ruta del archivo, convierto los \ en /, para que se pueda leer
var URI = strReplace("\\", "/", fl.getDocumentDOM().path);
//le doy nombre y añado file:/// para que pueda pasarse como parámetro de Fl.write
URI = "file:///"+URI.slice(0, URI.lastIndexOf("."))+"_LibraryData.xml";
fl.trace(URI);
//
//
//
//Empiezo a formar el xml
// "\n" es el carácter que indica salto de línea
var str = '<?xml version="1.0" encoding="utf-8" ?>\n<libraryItems>';
//
//
//
//Calculo la cantidad de objetos en la biblioteca
var ln = fl.getDocumentDOM().library.items.length;
//Copio la biblioteca a otro array para poder trabajar mejor
var lib = fl.getDocumentDOM().library.items;
//Ordeno el array por los nombre, con la función que definí arriba
lib.sort(nameSort);
var currentFolder = "";
var folders=new Array();
//
//
//
//Con cada item de la biblioteca...
for (i=0; i<ln; i++) {
	var indSmb = lib[i];
	//Creo un array con la ruta (las carpetas van separadas por /) y el nombre
	var pat = indSmb.name.split("/");
	var patLen = pat.length;
	//Si ya no estamos en la misma carpeta que en la recursión anterior...
	if (currentFolder != pat[patLen-2] && currentFolder != "") {
		//cerramos la etiqueta de la carpeta anterior
		str += '\n</'+currentFolder+'>';
		//la carpeta anterior es la carpeta padre
		folders.pop();
		currentFolder=folders[folders.length-1];
	}
	//Si el símbolo es una carpeta...
	if (indSmb.itemType == "folder") {
		//Se convierte en la carpeta actual
		currentFolder = pat[patLen-1];
		folders.push(currentFolder);
		//Abrimos la etiqueta
		str += '\n<'+currentFolder+'>';
		//
		//
		//
		//Si no...
	} else {
		//A cada elemento parseo lo atributos que interesan
		str += '\n<item  name="'+pat[patLen-1]+'" type="'+indSmb.itemType+'" linckageName="'+indSmb.linkageIdentifier+'" />';
	}
}
//Cierro las etiquetas que faltan
for(i=folders.length;i>0;i--){
	str += '\n</'+folders[i-1]+'>';
}
//Cierro el nodo y escribo la cadena en el archivo
str += '\n</libraryItems>';
FLfile.write(URI, str);
